#pragma once
namespace Themis {

/**
    CAllocator̎
*/
template<int S, int N> class CAllocatorImpl : private boost::noncopyable {
public:
    inline CAllocatorImpl(): m_nBlankCount(N) {
        for (int i = 0; i < N; i++) {
            m_anBlank[i] = i;  //ׂċ
        }
      #ifndef NDEBUG
        memset(m_abyMemory, 0xdb, sizeof(m_abyMemory));
      #endif
    }
    inline ~CAllocatorImpl() {
    }

    /// gĂȂ̌擾
    inline int GetBlankCount() {
        return m_nBlankCount;
    }
    /// noCg̃Allocate()ôǂ
    inline bool IsAllocatable(size_t n) {
        return 0 < m_nBlankCount && n <= S;
    }
    /// m
    inline void* Allocate(size_t) {
        m_nBlankCount--;
        int nBlank = m_anBlank[m_nBlankCount];
      #ifndef NDEBUG
        memset(&m_abyMemory[nBlank][0], 0xda, sizeof(m_abyMemory[nBlank]));
      #endif
        return &m_abyMemory[nBlank][0];     //󂫃ubNԂ
    }

    /// Allocate()ꂽȂ̂ǂB
    inline bool IsOwnMemory(void* p) {
        int n = static_cast<int>(static_cast<uint8_t*>(p) - &m_abyMemory[0][0]);
        return 0 <= n && n < sizeof(m_abyMemory);
    }
    /// 
    inline void Free(void* p) {
        Themis_DebugAssert(IsOwnMemory(p));
        int n = static_cast<int>(static_cast<uint8_t*>(p) - &m_abyMemory[0][0]);
        n /= S;
        m_anBlank[m_nBlankCount] = n;
        m_nBlankCount++;
      #ifndef NDEBUG
        memset(&m_abyMemory[n][0], 0xdf, sizeof(m_abyMemory[n]));
      #endif
    }

private:
    uint8_t m_abyMemory[N][S];
    int m_anBlank[N];
    int m_nBlankCount;
};


}
