#pragma once
namespace Themis {

// fobOpO\NX
class CAllocatorLog : private boost::noncopyable {
    const int   S;
    const int   N;
    int         m_nBlankMin;
    unsigned    m_nUseCount;
    unsigned    m_nDontUseCount;
    unsigned*   m_anUseCount;
    int         m_nLeakCount;
public:
    CAllocatorLog(int _S, int _N)
        : S(_S), N(_N), m_nBlankMin(_N), m_nUseCount(0), m_nDontUseCount(0), m_nLeakCount(0) {
        m_anUseCount = (unsigned*)::malloc(sizeof(unsigned) * (S / 16));
        std::fill(&m_anUseCount[0], &m_anUseCount[(S / 16)], unsigned(0));
    }

    ~CAllocatorLog() {
        Themis_DebugAlwaysLog(L"-------Allocator Info-------");
        Themis_DebugAlwaysLog(string::Format(L"ubNTCY@F%d bytes", S));
        Themis_DebugAlwaysLog(string::Format(L"ubN@@F%d ", N));
        Themis_DebugAlwaysLog(string::Format(L"gpʁ@F%d KB", S * N / 1024));
        Themis_DebugAlwaysLog(string::Format(L"[N^f@F%d ", m_nLeakCount));
        Themis_DebugAlwaysLog(string::Format(L"ő哯gp@F%u / %u ", (N - m_nBlankMin), N));
        Themis_DebugAlwaysLog(string::Format(L"vgp񐔁@@F%u ", m_nUseCount));
        Themis_DebugAlwaysLog(string::Format(L"vsgp񐔁@F%u ", m_nDontUseCount));
        Themis_DebugAlwaysLog(string::Format(L"ubNgp@F%d ", ::MulDiv(m_nUseCount, 100, m_nUseCount + m_nDontUseCount)));
        if (16 < S) {
            Themis_DebugAlwaysLog(L"ubNgpzF");
            for (int i = 0; i < (S / 16); i++) {
                Themis_DebugAlwaysLog(string::Format(L"@%3d - %3dF%5u", i*16 + 1, i*16+16, m_anUseCount[i]));
            }
        }
        Themis_DebugAlwaysLog(L"----------------------------");
        m_nUseCount = m_nDontUseCount = 0;
        m_nBlankMin = N;

     // free(m_anUseCount);
     // m_anUseCount = NULL;
    }

    void OnAllocBlock(size_t n, int m_nBlankCount) {
        m_nUseCount++;
        m_anUseCount[(n - 1) / 16]++;
        m_nLeakCount++;
        if (m_nBlankCount - 1 < m_nBlankMin) {
            m_nBlankMin = m_nBlankCount - 1;
        }
    }

    void OnAllocHeap(size_t n) {
        m_nLeakCount++;
        m_nDontUseCount++;
    }

    void OnFree() {
        m_nLeakCount--;
    }
};

// NX
class CAllocatorNoLog : private boost::noncopyable {
public:
    inline CAllocatorNoLog(int _S, int _N) {}
    inline ~CAllocatorNoLog() {}
    inline void OnAllocBlock(size_t n, int m_nBlankCount) {}
    inline void OnAllocHeap(size_t n) {}
    inline void OnFree() {}
};

}
