#include "stdafx.h"
#include "BatchFile.h"
#include "File.h"
#include "Windows/System.h"
#include "Windows/Process.h"
#include "Windows/Environment.h"
#include "String/StringBuilder.h"
#include "String/Encoding.h"
namespace Themis {

CBatchFile::CBatchFile() {
    builder.reset(new StringBuilder());
}

CBatchFile::~CBatchFile() {
}

void CBatchFile::Clear() {
    builder->Remove(0, builder->GetLength());
}

namespace {
    inline void AddPrm(StringBuilder& b, const string& p) {
        b.Append(L' ');
        b.Append(p);
    }
}
// _TCAdd()͑SRsyŁB

void CBatchFile::Add() {
    builder->AppendLine();
}

void CBatchFile::Add(const string& c) {
    builder->Append(c);
    builder->AppendLine();
}

void CBatchFile::Add(const string& c, const string& p1) {
    builder->Append(c);
    AddPrm(*builder, p1);
    builder->AppendLine();
}

void CBatchFile::Add(const string& c, const string& p1, const string& p2) {
    builder->Append(c);
    AddPrm(*builder, p1);
    AddPrm(*builder, p2);
    builder->AppendLine();
}

void CBatchFile::Add(const string& c, const string& p1, const string& p2, const string& p3) {
    builder->Append(c);
    AddPrm(*builder, p1);
    AddPrm(*builder, p2);
    AddPrm(*builder, p3);
    builder->AppendLine();
}

void CBatchFile::Add(const string& c, const string& p1, const string& p2, const string& p3, const string& p4) {
    builder->Append(c);
    AddPrm(*builder, p1);
    AddPrm(*builder, p2);
    AddPrm(*builder, p3);
    AddPrm(*builder, p4);
    builder->AppendLine();
}

void CBatchFile::Add(const string& c, const string& p1, const string& p2, const string& p3, const string& p4, const string& p5) {
    builder->Append(c);
    AddPrm(*builder, p1);
    AddPrm(*builder, p2);
    AddPrm(*builder, p3);
    AddPrm(*builder, p4);
    AddPrm(*builder, p5);
    builder->AppendLine();
}

void CBatchFile::Add(const string& c, const string& p1, const string& p2, const string& p3, const string& p4, const string& p5, const string& p6) {
    builder->Append(c);
    AddPrm(*builder, p1);
    AddPrm(*builder, p2);
    AddPrm(*builder, p3);
    AddPrm(*builder, p4);
    AddPrm(*builder, p5);
    AddPrm(*builder, p6);
    builder->AppendLine();
}

void CBatchFile::Save(const CFileName& oFileName) {
    std::string mb = Encoding::GetDefault().GetBytes(builder->ToString());
    CFile(oFileName).Save(mb);
}

namespace {
    void InnerRun(const CFileName& oFileName, int nShowCmd) {
        ProcessStartInfo info(oFileName.Get());
        info.WindowStyle = (ProcessWindowStyle::T)nShowCmd;
        info.WorkingDirectory = oFileName.GetDir();
        Process::Start(info);
    }
}
void CBatchFile::Run(const CFileName& oFileName) {
    Save(oFileName);
    InnerRun(oFileName, SW_SHOWNORMAL);
}
void CBatchFile::RunMinimize(const CFileName& oFileName) {
    Save(oFileName);
 // InnerRun(oFileName, SW_MINIMIZE);
    InnerRun(oFileName, SW_SHOWMINNOACTIVE);
}

void CBatchFile::RunReboot(const CFileName& oFileName) {
    CBatchFile oBatch;
    oBatch.Add(L"start", L"\"\"", CBatchFile::AddWQuote(CSystem::GetModuleFileName()));
    oBatch.Add(L"del", AddWQuote(oFileName.GetPureName()));
    oBatch.RunMinimize(oFileName);
}

}
