#pragma once
#include "ErrorListener.h"
#include "Variable.h"
#include "CalculatorImpl/Func.h"
namespace Themis {

/// Prepare()ӂׂ̈̃C^[tF[XB
class ICalculatorScanner;

/**
    vZ󂯂ƂČvZʂԂvZ@B

    Shift_JISQoCgϐE֐ȂǂƂĎgp\ɂĂ݂B

    0xŎn܂16iƁA0bŎn܂2iAL""ł̕(GXP[vV[PX\\\")ΉB

    ϐ . ł̃XR[vƁA[]ł̔zCfbNXwΉB
    A[]͌vZ10i̐ɕϊA: ؂ŕt̂ϐƂB
    Ƃ΁AL"themis.data[cos(6.28)*5.0]" ́AL"themis.data:4" ƂȂB

    ΉZq(P)F
        +, -, ~. !

    ΉZq(񍀁AP茋DxႢB̍sقǍA̍sقǒႢ)F
        *, /, %
        +, -,  >>, <<, &, |, ^
        >, >=, <, <=, ==, !=
        &&, ||

    Zq(񍀂DxႢBuc? a: bvƂƁAc^ȂaAUȂb̒lƂȂ)F
        ?:

    Ή֐(0`2)F
        rand
        rand, int, float, floor, ceil, abs, sqrt, sin, cos, tan, asin, acos, atan, sinh, cosh, tanh, log, log10, exp
        rand, min, max, pow, atan2
          0rand͐lԂB1rand́Astatic_cast<double>(rand()) / nRandMax * l
            2rand́Arand() % (y - x) + xA܂xy-1܂ł̐lԂB
            ̕ӂĂǂ̂ʓIȂ̂납BB

    Ɏg鉉ZqF
        +
        >, >=, <, <=, ==, !=

    ֐(strƕt̂A͐lB߂l͍sɁAlAAl(booll))F
        atoi(str), atof(str), length(str), indexof(str, str), lastindexof(str, str)
        itoa(n), ftoa(n), tolower(str), toupper(str), trim(str), at(str, n), replace(str, oldstr, newstr), Substring(str, pos, len)
        startswith(str, str), endswith(str, str)

    ̑̊֐
        defined(str)    ϐ𕶎ƂĎw肵A`Ă邩ǂԂ
*/
class CCalculator : private boost::noncopyable {
public:
    CCalculator();
    ~CCalculator();

    //@{ ϐ̒`E擾E`
    bool IsDefinedVariable(const string& strName);
    CVariable& CreateVariable(const string& strName);
    CVariable& GetVariable(const string& strName);
    void DeleteVariable(const string& strName);
    void ClearVariables();
    //@}

    //@{ ֐̒`Ȃ
    void AddFunction(const string& strName, CCalculatorFunc::TFunc fn) {
        AddFunction(strName, std::tr1::shared_ptr<CCalculatorFunc>(new CCalculatorFunc(fn)));
    }
    template<class T> void AddFunction(const string& strName, T* pThis, typename CCalculatorFuncMemFn<T>::TFunc fn) {
        AddFunction(strName, new CCalculatorFuncMemFn<T>(pThis, fn));
    }
    void AddFunction(const string& strName, const std::tr1::shared_ptr<ICalculatorFunc>& pFunc);
    void RemoveFunction(const string& strName);
    void ClearFunctions();
    //@}

    /// vZvZ
    CVariable Calc(const string& strExpression);
    /// J}؂ŕ␔̏ꂽ󂯎AꂼvZĕԂ
    CVariableArray CalcCommaDivided(const string& strParams);

    /// vZ̑O
    std::tr1::shared_ptr<ICalculatorScanner> Prepare(const string& str);
    /// vZvZ
    CVariable Calc(ICalculatorScanner& rScanner);
    /// J}؂ŕ␔̏ꂽ󂯎AꂼvZĕԂ
    CVariableArray CalcCommaDivided(ICalculatorScanner& rScanner);

    //@{ G[\R[obN
    void SetErrorListener(const std::tr1::shared_ptr<IErrorListener>& p) { m_pErrorListener = p; }
    const std::tr1::shared_ptr<IErrorListener>& GetErrorListener() const { return m_pErrorListener; }
    //@}

    /// Sp𔼊p֕ϊB͂ɂxZʂ𗘂ꍇpH
    static string Replace2Byte(const string& s);


    /// G[o
    void OnError(const string& strMsg) const;
    /// ֐̌Ăяo
    bool CallFunction(const string& strFunc, CVariable& rRet, const CVariableArray& vctParams);

private:
    /// ϐ̎擾(ȂNULL)
    CVariable* InnerGetVariable(const string& strName);

    CVariableArray GetFunctionParams(ICalculatorScanner& rScanner);
    CVariable Expression(ICalculatorScanner& rScanner);
    CVariable Expression2(ICalculatorScanner& rScanner);
    CVariable Expression3(ICalculatorScanner& rScanner);
    CVariable Term(ICalculatorScanner& rScanner);
    CVariable Term2(ICalculatorScanner& rScanner);
    CVariable Factor(ICalculatorScanner& rScanner);
    string Selector(ICalculatorScanner& rScanner);

    typedef std::map<string, std::tr1::shared_ptr<CVariable> >         TVarList;
    typedef std::map<string, std::tr1::shared_ptr<ICalculatorFunc> >   TFuncList;

private:
    std::tr1::shared_ptr<IErrorListener> m_pErrorListener;
    TVarList m_oVarList;
    TFuncList m_oFuncList;
};

}
