#pragma once
#include "ImplData.h"
namespace Themis {

struct ChooseFileData;

/** t@CJۑƂ̃_CAOB

    RsypTv
@code

        CChooseFile m_oChooseFile;
        m_oChooseFile.SetOwner(m_pWindow->GetHandle());
        m_oChooseFile.SetTitle(L"t@CI_CAO");
        m_oChooseFile.ClearNameFilter();
        m_oChooseFile.AddNameFilter(L"Text File", L"*.txt");
        m_oChooseFile.AddNameFilter(L"All Files", L"*.*");
        m_oChooseFile.SetCurrentDir(strCurrentDir);
        m_oChooseFile.SetDefaultExt(L"txt");
        m_oChooseFile.SetDefault(L"");
        if (m_oChooseFile.ShowOpen()) {
            //JƂ̏
        }

@endcode
*/
class CChooseFile : private boost::noncopyable {
    ImplData<ChooseFileData> data;
public:
    CChooseFile();
    ~CChooseFile();

    /// I[i[EBhE̐ݒ
    void SetOwner(HWND hWnd);
    /// _CAÕ^Cgݒ
    void SetTitle(const string& strTitle);

    /// NameFilterJb|ɁB
    void ClearNameFilter();
    /** t@C̃tB^ǉB

        strExplanation = L"HTML files";
        strFileNameFilter = L"*.htm;*.html";
        ƂƁA_CAÓut@C̎(T)v̂ƂɁA
        HTML files (*.htm;*.html) ƕ\A
        gqhtmEhtml̃t@CI悤ɂȂ */
    void AddNameFilter(const string& strExplanation, const string& strFileNameFilter);

    //@{ fBNg̐ݒƐݒ
    void SetCurrentDir(const CFileName& str);
    CFileName GetCurrentDir() const;
    //@}

    //@{ t@C݂ĂȂ΂ȂȂǂ
    void SetFileMustExist(bool b);
    bool IsFileMustExist() const;
    //@}

    /// ftHg̊gqw(ShowSave()łgȂH)
    void SetDefaultExt(const string& strExt);

    /// ftHgt@C̐ݒBxShown֐Ă񂾂NÂƂB
    void SetDefault(const string& strPureName);

    /// t@CJ_CAO
    bool ShowOpen();
    /// t@CJ_CAÔQFIA
    bool ShowOpenMulti();
    /// t@Cۑ_CAO
    bool ShowSave();

    /// t@C̎擾
    int GetResultCount() const;
    /// t@C̎擾
    const CFileName& GetResult(int n = 0) const;
    /// ʂ̎擾
    const vector<CFileName>& GetResults() const;

private:
    bool InnerShow(void* pfn, bool bMulti); //BOOL (WINAPI* fn)(OPENFILENAME*)
    BOOL InnerShow2(void* pfn, bool bMulti);
    void ReplaceInvalidChar(char* psz);

    static UINT CALLBACK HookProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
};

////////////////////////////////////////////////////////////////////////////////

/**
    tH_₢킹_CAO\B

    tH_̍ṒɁB

    CChooseDir m_oChooseDir;
    m_oChooseDir.SetOwner(m_pWindow->GetHandle());
    m_oChooseDir.SetTitle(L"tH_I_CAO");
    m_oChooseDir.SetDefault(strCurrentDir);
    if (m_oChooseDir.Show()) {
        //IƂ̏
    }
*/
class CChooseDir : private boost::noncopyable {
public:
    CChooseDir();
    ~CChooseDir();

    /// eݒ
    void SetOwner(HWND hwndOwner);
    /// ^Cgݒ
    void SetTitle(const string& szTitle);

    /// fBNgݒ
    void SetDefault(const CFileName& oDir);

    /// tH_I_CAO\
    bool Show();

    /// IꂽtH_̎擾
    const CFileName& GetResult() const { return m_oResult; }

private:
    /// fBNgwpɃR[obN֐B
    static int CALLBACK BrowseCallbackProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);

private:
    string          m_strTitle;
    void*           m_pMalloc;      //IMalloc
    void*           m_pBrwsInfo;    //BROWSEINFO
    CFileName       m_oResult;
};

////////////////////////////////////////////////////////////////////////////////

/**
    FI_CAO

    CChooseColor m_oChooseColor;
    m_oChooseColor.SetOwner(m_pWindow->GetHandle());
    m_oChooseColor.SetCustColors(...);
    m_oChooseColor.LoadFromString(...);
    m_oChooseColor.SetDefault(RGB(0x00, 0x00, 0x00));
    if (m_oChooseColor.Show()) {
        // IꂽƂ̏
    }
*/
class CChooseColor : private boost::noncopyable {
public:
    CChooseColor();
    ~CChooseColor();

    /// I[i[EBhE̐ݒ
    void SetOwner(HWND hWnd);

    /// JX^pbgݒ
    void SetCustColors(COLORREF argbColor[0x10]);
    /// JX^pbg̎擾
    COLORREF* GetCustColors() { return m_argbCustColor; }

    /// JX^pbg𕶎(ݒۑp)
    string SaveToString() const;
    /// 񉻂ꂽJX^pbgl𕜌
    void LoadFromString(const string& str);

    /// ftHgFݒ
    void SetDefault(COLORREF rgb) { m_rgbResult = rgb; }

    /// LZꂽfalse
    bool Show();

    /// ʂ̎擾
    COLORREF GetResult() const { return m_rgbResult; }

private:
    void*       m_cc;                   //CHOOSECOLOR
    COLORREF    m_rgbResult;
    COLORREF    m_argbCustColor[0x10];
};

////////////////////////////////////////////////////////////////////////////////

/**
    tHgI_CAO
*/
class CChooseFont : private boost::noncopyable {
public:
    CChooseFont();
    ~CChooseFont();

    /// eZbg
    void SetOwner(HWND hWnd);

    /// ŏɑIĂFݒ
    void SetColor(COLORREF rgb);

    /// _CAO\[
    bool Show(LOGFONT& rLogFont, COLORREF& rgbColor);

private:
    void* m_cf; //CHOOSEFONT
};

}
