#pragma once
#include "DataObject.h"
namespace Themis {

/**
    p[^[tCDataObject
*/
template<class C, class P, class T> class CDataObject2: public CDataObjectBase<CDataObject2<C, P, T>, T> {
public:
    typedef typename boost::call_traits<P>::param_type param_p;
    typedef void (C::* FnSetter)(param_p p, TValueParam t);
    typedef T (C::* FnGetter)(param_p p) const;
    CDataObject2(C* o, param_p p, FnSetter s, FnGetter g)
        : m_pObj(o), m_fnSetter(s), m_fnGetter(g), m_p(p) {}
    ~CDataObject2() {}
    inline void Set(TValueParam t) const { (m_pObj->*m_fnSetter)(m_p, t); }
    inline TValue Get() const { return (m_pObj->*m_fnGetter)(m_p); }
private:
    C*          m_pObj;
    FnSetter    m_fnSetter;
    FnGetter    m_fnGetter;
    P           m_p;
};


/**
    Ot񃊃XgB

    Format`Value/Get`Valueӂ΂FXo邩B
    ́uږ = l\r\nv̌JԂB
    ̏ɊYȂs͑SB

    Save/Load̓RXgN^ƂŎgꍇāA
    catcĥʓ|AsĂ\Ȃꍇ̂ŁA
    sȂfalseԂdlƂB
*/
class CConfig : private boost::noncopyable {
public:
    CConfig();
    ~CConfig();

    /// Sڂ̍폜
    void Clear();
    /// ڂ̍폜
    void Delete(const string& strName);
    /// ڂ̂ǂ
    bool Exists(const string& strName) const;
    /// ږ̕ύX
    void ChanegName(const string& strName1, const string& strName2);

    /// ږ̗
    vector<string> GetNames() const;
    /// ږEf[^̗
    vector<pair<string, string> > GetValues() const;

    //@{ l̐ݒ
    void Str(const string& strName, const string& strValue);
    void Num(const string& strName, int nValue);
    void Float(const string& strName, boost::call_traits<double>::param_type dValue);
    void Bool(const string& strName, bool b);
    void Bin(const string& strName, const pair<const void*, size_t>& p);
    void Bin(const string& strName, const vector<uint8_t>& r);
    void Point(const string& strName, const CPoint& pt);
    void Size(const string& strName, const CSize& sz);
    void Rect(const string& strName, const CRect& rc);
    void File(const string& strName, const string& strFileName);
    void Color(const string& strName, COLORREF rgbValue);
    void Indirect(const string& strName, const string& strValue);
    //@}
    //@{ l̎擾
    string Str(const string& strName) const;
    int Num(const string& strName) const;
    double Float(const string& strName) const;
    bool Bool(const string& strName) const;
    vector<uint8_t> Bin(const string& strName) const;
    CPoint Point(const string& strName) const;
    CSize Size(const string& strName) const;
    CRect Rect(const string& strName) const;
    COLORREF Color(const string& strName) const;
    string Indirect(const string& strName) const;
    string File(const string& strName) const { return Indirect(strName); }
    //@}
    //@{ 擾Eݒ
    inline CDataObject2<CConfig, const string&, string> StrData(const string& s) { return CDataObject2<CConfig, const string&, string>(this, s, &CConfig::Str, &CConfig::Str); }
    inline CDataObject2<CConfig, const string&, int> NumData(const string& s) { return CDataObject2<CConfig, const string&, int>(this, s, &CConfig::Num, &CConfig::Num); }
    inline CDataObject2<CConfig, const string&, double> FloatData(const string& s) { return CDataObject2<CConfig, const string&, double>(this, s, &CConfig::Float, &CConfig::Float); }
    inline CDataObject2<CConfig, const string&, bool> BoolData(const string& s) { return CDataObject2<CConfig, const string&, bool>(this, s, &CConfig::Bool, &CConfig::Bool); }
    inline CDataObject2<CConfig, const string&, vector<uint8_t> > BinData(const string& s) { return CDataObject2<CConfig, const string&, vector<uint8_t> >(this, s, &CConfig::Bin, &CConfig::Bin); }
    inline CDataObject2<CConfig, const string&, CPoint> PointData(const string& s) { return CDataObject2<CConfig, const string&, CPoint>(this, s, &CConfig::Point, &CConfig::Point); }
    inline CDataObject2<CConfig, const string&, CSize> SizeData(const string& s) { return CDataObject2<CConfig, const string&, CSize>(this, s, &CConfig::Size, &CConfig::Size); }
    inline CDataObject2<CConfig, const string&, CRect> RectData(const string& s) { return CDataObject2<CConfig, const string&, CRect>(this, s, &CConfig::Rect, &CConfig::Rect); }
    inline CDataObject2<CConfig, const string&, COLORREF> ColorData(const string& s) { return CDataObject2<CConfig, const string&, COLORREF>(this, s, &CConfig::Color, &CConfig::Color); }
    inline CDataObject2<CConfig, const string&, string> IndirectData(const string& s) { return CDataObject2<CConfig, const string&, string>(this, s, &CConfig::Indirect, &CConfig::Indirect); }
    inline CDataObject2<CConfig, const string&, string> FileData(const string& s) { return CDataObject2<CConfig, const string&, string>(this, s, &CConfig::File, &CConfig::File); }
    //@}

    /// L"W[.cfg"̎擾
    static CFileName GetDefaultFileName();

    /// t@C֏o(L"W[.cfg")
    bool Save() const;
    /// t@Cǂݏo(L"W[.cfg")
    bool Load();
    /// t@C֏o
    bool Save(const CFileName& oFileName) const;
    /// t@Cǂݏo
    bool Load(const CFileName& oFileName);

    /// RtBOf[^𕶎֕ϊ
    string SaveToStr() const;
    /// 񂩂RtBOf[^쐬
    void LoadFromStr(const string& str);

protected:
    std::map<string, string>::const_iterator GetBegin() const { return m_oDataList.begin(); }
    std::map<string, string>::const_iterator GetEnd() const { return m_oDataList.end(); }
    std::map<string, string>::const_iterator Find(const string& str) const { return m_oDataList.find(str); }

private:
    string FormatStrValue(const string& strValue) const;
    string FormatBinValue(const void* p, size_t nSize) const;
    string GetStrValue(const string& strValue) const;
    void GetBinValue(const string& str, void* p) const;
    //@{ ̕ɂ܂Ƃ߂A
    string GetStorageStr(const string& strName, const string& strValue) const;
    bool SetStorageStr(const string& strStorage);
    //@}

private:
    std::map<string, string> m_oDataList;
};

}
