#pragma once
#include "Utility/StringUtility.h"
namespace Themis {

/**
    CStorage _TData ƁAۂɈ _TValue Ƃ̑ݕϊŝ̃x[XNX

    EncodeF TValue  TData ̕ϊiۑɎgj
    DecodeF TData  TValue ̕ϊiǂݏoɎgj
*/
template<class _TData, class _TValue> class CConfigEncoderBase : private boost::noncopyable {
public:
    typedef _TData TData;
    typedef _TValue TValue;
    typedef typename boost::call_traits<TData>::param_type TDataParam;
    typedef typename boost::call_traits<TValue>::param_type TValueParam;
 // hNXŎB
 // static TValue Decode(TDataParam t);
 // static TData Encode(TValueParam t);
};

//@ TData == string ȁAef[^^CvpGR[_[
struct CConfigNumEncoder : public CConfigEncoderBase<string, int> {
    static inline TData Encode(TValueParam t) { return ItoA(t); }
    static inline TValue Decode(TDataParam t) { return AtoI(t); }
};
struct CConfigBoolEncoder : public CConfigEncoderBase<string, bool> {
    static inline TData Encode(TValueParam t) { return t ? L"true" : L"false"; } // falsełȂΗOɂׂcH
    static inline TValue Decode(TDataParam t) { return t == L"true"; }
};
struct CConfigFloatEncoder : public CConfigEncoderBase<string, double> {
    static inline TData Encode(TValueParam t) { return FtoA(t); }
    static inline TValue Decode(TDataParam t) { return AtoF(t); }
};
struct CConfigBinEncoder : public CConfigEncoderBase<string, vector<uint8_t> > {
    static TData Encode(TValueParam t);
    static TValue Decode(TDataParam t);
};
struct CConfigStrEncoder : public CConfigEncoderBase<string, string> {
    static TData Encode(TValueParam t);
    static TValue Decode(TDataParam t);
};
struct CConfigPointEncoder : public CConfigEncoderBase<string, CPoint> {
    static TData Encode(TValueParam t);
    static TValue Decode(TDataParam t);
};
struct CConfigSizeEncoder : public CConfigEncoderBase<string, CSize> {
    static TData Encode(TValueParam t);
    static TValue Decode(TDataParam t);
};
struct CConfigRectEncoder : public CConfigEncoderBase<string, CRect> {
    static TData Encode(TValueParam t);
    static TValue Decode(TDataParam t);
};
struct CConfigColorEncoder : public CConfigEncoderBase<string, COLORREF> {
    static TData Encode(TValueParam t);
    static TValue Decode(TDataParam t);
};
struct CConfigLineEncoder : public CConfigEncoderBase<string, string> {
    static inline TData Encode(TValueParam t) { return t; }
    static inline TValue Decode(TDataParam t) { return t; }
};
//@}

/// ϊsȂGR[_[
template<class T> struct CConfigPlainEncoder : public CConfigEncoderBase<T, T> {
    static inline TData Encode(TValueParam t) { return t; }
    static inline TValue Decode(TDataParam t) { return t; }
};

}
