#include "stdafx.h"
#include "Rand.h"
#include "MD5.h"
#include "Encode.h"
namespace Themis {

CLZSSCompress::CLZSSCompress() {
}

CLZSSCompress::~CLZSSCompress() {
}

void CLZSSCompress::Encode(IWriteStream& rDstStream, const IReadStream& rSrcStream) {
    // g[^TCY̏
    {
        uint32_t nSrcTotalSize = static_cast<uint32_t>(rSrcStream.GetTotalSize());
        if (nSrcTotalSize <= 16) {
            throw RuntimeException(L"kf[^܂");
        }
        rDstStream.Write(&nSrcTotalSize, sizeof(nSrcTotalSize));
    }

    int i, c, len, r, s, lastmatchlen, codeptr;
    uint8_t code[17], mask;

    // ؂
    for (i = RING_BUFSIZE + 1; i <= RING_BUFSIZE + 256; i++) {
        m_rsn[i] = NIL;
    }
    for (i = 0; i < RING_BUFSIZE; i++) {
        m_dad[i] = NIL;
    }

    code[0] = 0;
    codeptr = mask = 1;
    s = 0;
    r = RING_BUFSIZE - LONGEST_MATCH;
    for (i = s; i < r; i++) {
        m_abyText[i] = 0;  // obt@
    }

    const uint8_t* pbySrc = static_cast<const uint8_t*>(rSrcStream.GetBuffer());
    size_t nSrcSize = rSrcStream.GetBufferSize();

    for (len = 0; len < LONGEST_MATCH ; len++) {
        c = *(pbySrc++);
        if (--nSrcSize <= 0) {
            if (rSrcStream.ToNextBuffer()) { // ̃obt@
                pbySrc = static_cast<const uint8_t*>(rSrcStream.GetBuffer());
                nSrcSize = rSrcStream.GetBufferSize();
            } else { // Ȃ炨I
                break;
            }
        }
        m_abyText[r + len] = static_cast<uint8_t>(c);
    }
    if (len == 0) {
        throw RuntimeException(L"悭Ȃǈk̃G[ۂł");
    }
    for (i = 1; i <= LONGEST_MATCH; i++) InsertNode(r - i);
    InsertNode(r);

    CStreamWriter oDst(rDstStream);

    do {
        if (m_matchlen > len) m_matchlen = len;
        if (m_matchlen < 3) {
            m_matchlen = 1;
            code[0] |= mask;
            code[codeptr++] = m_abyText[r];
        } else {
            code[codeptr++] = (uint8_t) m_matchpos;
            code[codeptr++] = (uint8_t)
                (((m_matchpos >> 4) & 0xf0) | (m_matchlen - 3));
        }
        if ((mask <<= 1) == 0) {
            for (i = 0; i < codeptr; i++) {
                oDst.Write(uint8_t(code[i]));
            }
            code[0] = 0;
            codeptr = mask = 1;
        }
        lastmatchlen = m_matchlen;
        for (i = 0; i < lastmatchlen; i++) {
            if (nSrcSize == 0) {
                if (rSrcStream.ToNextBuffer()) { // ̃obt@
                    pbySrc = static_cast<const uint8_t*>(rSrcStream.GetBuffer());
                    nSrcSize = rSrcStream.GetBufferSize();
                } else { // Ȃ炨I
                    break;
                }
            }
            nSrcSize--;
            c = *(pbySrc++);
            DeleteNode(s);
            m_abyText[s] = static_cast<uint8_t>(c);
            if (s < LONGEST_MATCH - 1) m_abyText[s + RING_BUFSIZE] = static_cast<uint8_t>(c);
            s = (s + 1) & (RING_BUFSIZE - 1);
            r = (r + 1) & (RING_BUFSIZE - 1);
            InsertNode(r);
        }
        while (i++ < lastmatchlen) {
            DeleteNode(s);
            s = (s + 1) & (RING_BUFSIZE - 1);
            r = (r + 1) & (RING_BUFSIZE - 1);
            if (--len) InsertNode(r);
        }
    } while (len > 0);
    if (codeptr > 1) {
        for (i = 0; i < codeptr; i++) {
            oDst.Write(uint8_t(code[i]));
        }
    }
}

void CLZSSCompress::InsertNode(int r) {
    int i, p, cmp;
    uint8_t* key;

    cmp = 1;
    key = &m_abyText[r];
    p = RING_BUFSIZE + 1 + key[0];
    m_rsn[r] = m_lsn[r] = NIL;
    m_matchlen = 0;
    while (true) {
        if (cmp >= 0) {
            if (m_rsn[p] != NIL) {
                p = m_rsn[p];
            } else {
                m_rsn[p] = r;
                m_dad[r] = p;
                return;
            }
        } else {
            if (m_lsn[p] != NIL) {
                p = m_lsn[p];
            } else {
                m_lsn[p] = r;
                m_dad[r] = p;
                return;
            }
        }
        for (i = 1; i < LONGEST_MATCH; i++) {
            if ((cmp = key[i] - m_abyText[p + i]) != 0)  {
                break;
            }
        }
        if (i > m_matchlen) {
            m_matchpos = p;
            if ((m_matchlen = i) >= LONGEST_MATCH) {
                break;
            }
        }
    }
    m_dad[r] = m_dad[p];
    m_lsn[r] = m_lsn[p];
    m_rsn[r] = m_rsn[p];
    m_dad[m_lsn[p]] = r;
    m_dad[m_rsn[p]] = r;
    if (m_rsn[m_dad[p]] == p) {
        m_rsn[m_dad[p]] = r;
    } else  {
        m_lsn[m_dad[p]] = r;
    }
    m_dad[p] = NIL;  // p O
}

void CLZSSCompress::DeleteNode(int p) {
    int  q;
    if (m_dad[p] == NIL) return;  // Ȃ
    if (m_rsn[p] == NIL) {
        q = m_lsn[p];
    } else if (m_lsn[p] == NIL) {
        q = m_rsn[p];
    } else {
        q = m_lsn[p];
        if (m_rsn[q] != NIL) {
            do {  q = m_rsn[q];  } while (m_rsn[q] != NIL);
            m_rsn[m_dad[q]] = m_lsn[q];
            m_dad[m_lsn[q]] = m_dad[q];
            m_lsn[q] = m_lsn[p];
            m_dad[m_lsn[p]] = q;
        }
        m_rsn[q] = m_rsn[p];
        m_dad[m_rsn[p]] = q;
    }
    m_dad[q] = m_dad[p];
    if (m_rsn[m_dad[p]] == p) {
        m_rsn[m_dad[p]] = q;
    } else {
        m_lsn[m_dad[p]] = q;
    }
    m_dad[p] = NIL;
}

void CLZSSCompress::Decode(IWriteStream& rDstStream, const IReadStream& rSrcStream) {
    if (rSrcStream.GetTotalSize() <= 16) {
        throw RuntimeException(L"𓀂f[^܂");
    }

    int i, j, k, r, c;
    r = RING_BUFSIZE - LONGEST_MATCH;

    const uint8_t* pbySrc = static_cast<const uint8_t*>(rSrcStream.GetBuffer());
    size_t nSrcSize = rSrcStream.GetBufferSize();

    size_t nDstSize = *reinterpret_cast<const uint32_t*>(pbySrc);
    pbySrc += sizeof(size_t);
    nSrcSize -= sizeof(size_t);

    uint32_t dwFlags = 0;

    memset(m_abyText, 0x00, sizeof(m_abyText));

    if (rSrcStream.GetBufferSize() != rSrcStream.GetTotalSize()) {
        Themis_DebugWarning(L"蔲[");
        throw RuntimeException(L"̓Xg[`ɖΉłB");
    }

    CStreamWriter oDst(rDstStream);

    while (true) {
        if (((dwFlags >>= 1) & 256) == 0) {
            c = *(pbySrc++);
            dwFlags = c | 0xff00;
        }
        if (dwFlags & 1) {
            c = *(pbySrc++);
            oDst.Write(static_cast<uint8_t>(c));
            if (--nDstSize == 0) {
                return; // I
            }
            m_abyText[r++] = static_cast<uint8_t>(c);
            r &= (RING_BUFSIZE - 1);
        } else {
            i = *(pbySrc++);
            j = *(pbySrc++);
            i |= ((j & 0xf0) << 4);
            j = (j & 0x0f) + 2;
            for (k = 0; k <= j; k++) {
                c = m_abyText[(i + k) & (RING_BUFSIZE - 1)];
                oDst.Write(static_cast<uint8_t>(c));
                if (--nDstSize == 0) {
                    return; // I
                }
                m_abyText[r++] = static_cast<uint8_t>(c);
                r &= (RING_BUFSIZE - 1);
            }
        }
    }
}

}
