namespace Themis {

//GtFNgȂ
CRect CPlaneEffectNoEffect::InnerRender(CPlaneEx& rDstPlane) const {
    const_cast<CPlaneEffectNoEffect*>(this)->SetMaxFrame(1);   //Iɐݒ
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.Blt(m_rSrc, rc);
    return rc;
}

//tF[hAEg
CRect CPlaneEffectFadeOut::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.FadeBlt(m_rSrc, CPoint(), rc, GetEffect(0x100));
    return rc;
}

//tF[hC
CRect CPlaneEffectFadeIn::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.FadeBlt(m_rSrc, CPoint(), rc, GetEffectReverse(0x100));
    return rc;
}

//zCgAEg
CRect CPlaneEffectWhiteOut::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.BrightBlt(m_rSrc, CPoint(), rc, GetEffect(0x100));
    return rc;
}

//zCgC
CRect CPlaneEffectWhiteIn::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.BrightBlt(m_rSrc, CPoint(), rc, GetEffectReverse(0x100));
    return rc;
}

//NXtF[h
CRect CPlaneEffectCrossFade::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize().GetUnion(m_rSrc2.GetSize())); //ꉞ傫ɍ킹
    rDstPlane.BlendBlt(m_rSrc, m_rSrc2, CPoint(), rc, GetEffectReverse(0x100));
    return rc;
}

//UCN
CRect CPlaneEffectMosaic::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize().GetUnion(m_rSrc2.GetSize())); //ꉞ傫ɍ킹
    int nMosaicMax = Min(rc.GetWidth(), rc.GetHeight()) / 2;           //̔őlƂ
    int nMosaic = GetEffect(nMosaicMax * 2);
    if (nMosaic <= nMosaicMax) {
        rDstPlane.Blt(m_rSrc, CPoint(), rc);
        rDstPlane.MosaicFill(rc, nMosaic);
    } else {
        rDstPlane.Blt(m_rSrc2, CPoint(), rc);
        rDstPlane.MosaicFill(rc, nMosaicMax * 2 - nMosaic);
    }
    return rc;
}

//}XNtF[hAEg
CRect CPlaneEffectMaskFadeOut::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.MaskFadeBlt(m_rSrc, m_rMask, CPoint(), rc, GetEffectReverse(0x100 + m_nVague) - m_nVague, m_nVague);
    return rc;
}

//}XNtF[hC
CRect CPlaneEffectMaskFadeIn::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.MaskFadeBlt(m_rSrc, m_rMask, CPoint(), rc, GetEffect(0x100 + m_nVague), m_nVague);
    return rc;
}

//}XNzCgAEg
CRect CPlaneEffectMaskWhiteOut::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.MaskBrightBlt(m_rSrc, m_rMask, CPoint(), rc, GetEffectReverse(0x100 + m_nVague) - m_nVague, m_nVague);
    return rc;
}

//}XNzCgC
CRect CPlaneEffectMaskWhiteIn::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize());
    rDstPlane.MaskBrightBlt(m_rSrc, m_rMask, CPoint(), rc, GetEffect(0x100 + m_nVague), m_nVague);
    return rc;
}

//}XNNXtF[h
CRect CPlaneEffectMaskCrossFade::InnerRender(CPlaneEx& rDstPlane) const {
    CRect rc = GetClipedRect(m_rSrc.GetSize().GetUnion(m_rSrc2.GetSize())); //ꉞ傫ɍ킹
    rDstPlane.MaskBlendBlt(m_rSrc, m_rSrc2, m_rMask, CPoint(), rc, GetEffectReverse(0x100 + m_nVague) - m_nVague, m_nVague);
    return rc;
}

}
