#pragma once
#include "../_config.h"
#include "Image.h"
typedef struct png_struct_def png_struct;
typedef struct png_info_struct png_info;
namespace Themis {

#if Themis_ConfigPngLib

/**
    PNG̓ǂݍ݃NX
*/
class CPngLoader: public IImageLoader {
public:
    CPngLoader();
    ~CPngLoader();

    bool Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce);
    CSize GetSize() const;
    void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce);
    bool HasAlpha() const { return m_bAlpha; }
    string GetTypeName() const { return L"PNG"; }
    string GetTypeFileName() const { return L"*.png"; }

    static string GetCopyright();

    struct SFileData {
        std::tr1::shared_ptr<CFileData> fileData;
        size_t nPos;
        SFileData(const std::tr1::shared_ptr<CFileData>& f, size_t n) : fileData(f), nPos(n) {}
    };

private:
    png_struct*             m_png_ptr;
    png_info*               m_info_ptr;
    auto_ptr<SFileData>     m_pFileData;
    auto_ptr<CMemoryPlane>  m_pPlane;
    CSize                   m_szImage;
    bool                    m_bAlpha;
};

/**
    PNG̏oNX
*/
class CPngSaver: public IImageSaver {
public:
    CPngSaver();
    ~CPngSaver();

    /// 0`9ňk̎wB
    //
    // #define Z_NO_COMPRESSION         0
    // #define Z_BEST_SPEED             1
    // #define Z_BEST_COMPRESSION       9
    // #define Z_DEFAULT_COMPRESSION  (-1)
    //
    CPngSaver& SetCompressLevel(int nCompression);

    void Save(const CFileName& oFileName, const CPlane& src, const CRect& rc);
    void Save(IWriteStream& rStream, const CPlane& src, const CRect& rc);

private:
    png_struct*     m_png_ptr;
    png_info*       m_info_ptr;
};

/// PNGt@Cǂݍ݃NXFactory
typedef DefaultFactory<CPngLoader, IImageLoader>   CPngLoaderFactory;

#endif//Themis_ConfigPngLib

}
