#pragma once
#include "TwowayMap.h"
namespace Themis {

struct SKeyTableData;

/**
    O`̃L[R[hƁAzL[R[h̑ݕϊȂǂsB
*/
class CKeyTable : private boost::noncopyable {
public:
    // CL[
    enum {
        eModCtrl = 0x01,
        eModAlt = 0x02,
        eModShift = 0x04,
        eModWin = 0x08
    };
    // L[
    enum EKey {
        // p(26)
        eKeyA, eKeyB, eKeyC, eKeyD, eKeyE, eKeyF,
        eKeyG, eKeyH, eKeyI, eKeyJ, eKeyK, eKeyL,
        eKeyM, eKeyN, eKeyO, eKeyP, eKeyQ, eKeyR,
        eKeyS, eKeyT, eKeyU, eKeyV, eKeyW, eKeyX, eKeyY, eKeyZ,
        // (10)
        eKey1, eKey2, eKey3, eKey4, eKey5, eKey6, eKey7, eKey8, eKey9, eKey0,
        // t@NV(12)
        eKeyF1, eKeyF2, eKeyF3, eKeyF4, eKeyF5, eKeyF6,
        eKeyF7, eKeyF8, eKeyF9, eKeyF10, eKeyF11, eKeyF12,
        // (20)
        eKeyEsc, eKeyPause, eKeyBack,
        eKeyMinus, eKeyPlus, eKeyTab, eKeyEnter,
        eKeyInsert, eKeyDelete, eKeyHome, eKeyEnd, eKeyPageUp, eKeyPageDown,
        eKeyComma, eKeyPeriod, eKeySpace,
        eKeyUp, eKeyLeft, eKeyDown, eKeyRight,
        // eL[(16)
        eKeyNum0, eKeyNum1, eKeyNum2, eKeyNum3, eKeyNum4, eKeyNum5, eKeyNum6, eKeyNum7, eKeyNum8, eKeyNum9,
        eKeyNumAdd, eKeyNumSub, eKeyNumMul, eKeyNumDiv,
        // }EX(8)
        eKeyLClick, eKeyLDouble, eKeyRClick, eKeyRDouble,
        eKeyMClick, eKeyMDouble, eKeyMUp, eKeyMDown,
        eKey4Click, eKey4Double, eKey5Click, eKey5Double,   //4,5{^
        eKeyRLClick, eKeyLRClick,   //ENbN, ENbN
        // L[̐
        c_nKeyCount,
    };

    //@{ EKeyƃL[̖Ȏݕϊ
    static string GetKeyName(EKey eKey);
    static string GetKeyName(EKey eKey, int nModifiers);
    static string GetKeyName(const pair<EKey, int>& p) { return GetKeyName(p.first, p.second); }
    static pair<EKey, int> GetKey(const string& str);
    static pair<UINT, int> GetVKey(const string& str);
    //@}

    //@{ OS̉zL[R[hEKey̑ݕϊBŶꍇ͂ǂ-1BEKey  VKey͒x̂ŒӁB
    static EKey VKeyToEKey(UINT nVirtualKeyCode);
    static UINT EKeyToVKey(EKey eKey);
    //@}

    /// ݂̏CL[Ԃ擾(݂̃Xbhɑ鑋ꍇ)
    static int GetModifiers();
    /// ݂̏CL[Ԃ擾(Xbh)
    static int GetModifiersAsync();

private:
    static SKeyTableData& GetData();
};

}
