#pragma once
#include "ProgressListener.h"
namespace Themis {

class CConfig;
class CTempDir;
struct SHttpReceiveData;
class WorkerThreadController;

/**
    XVt@C̏
*/
class CNetworkUpdateInfo {
public:
    struct SFile {
        string  strName;    // t@C
        string  strTime;    // XV
        string  strMD5;     // t@CMD5
        int     nSize;      // t@CTCY
        SFile();
        string ToStr() const;
    };
    struct SEntry {
        string  strSrc;     // ɓt@C or Rs[t@C
        string  strDst;     // Rs[tH_ or Rs[t@C
        bool    bBackup;    // obNAbv邩ǂ
        bool    bDelete;    // 폜t@CȂ̂ǂ
        SEntry();
        string ToStr() const;
    };
    struct SNotice {
        string  strData;    // Ƃ肠ꂾBB
        SNotice();
        string ToStr() const;
    };

    CNetworkUpdateInfo();
    ~CNetworkUpdateInfo();

    //@{ t@C̒ǉ폜㉺擾BAddstrNameݒ肵ƂOK
    void AddFile(const SFile& oFile);
    void DelFile(int i);
    bool UpFile(int i);
    bool DownFile(int i);
    int GetFileCount() const;
    SFile& GetFile(int i);
    const SFile& GetFile(int i) const;
    //@}
    //@{ Gg̒ǉ폜㉺擾
    void AddEntry(const SEntry& oEntry);
    void DelEntry(int i);
    bool UpEntry(int i);
    bool DownEntry(int i);
    int GetEntryCount() const;
    SEntry& GetEntry(int i);
    const SEntry& GetEntry(int i) const;
    //@}
    //@{ m̒ǉ폜㉺擾
    void AddNotice(const SNotice& oNotice);
    void DelNotice(int i);
    bool UpNotice(int i);
    bool DownNotice(int i);
    int GetNoticeCount() const;
    SNotice& GetNotice(int i);
    const SNotice& GetNotice(int i) const;
    //@}

    //@{ f[^̓ǂݍ
    void Load(const CFileName& oFileName);
    void LoadFromStr(const string& strData);
    //@}
    /// t@C̍XVƃTCYݒ
    void UpdateFileTimeSize();
    /// f[^XVĂۑ
    void Save(const CFileName& oFileName);

    /// t@CTCY̍v擾
    int GetFileSizeSum() const;

private:
    vector<SFile>       m_oFileData;
    vector<SEntry>      m_oEntryData;
    vector<SNotice>     m_oNoticeData;
};


/**
*/
class CNetworkUpdaterBase : private IProgressListener {
public:
    CNetworkUpdaterBase();
    ~CNetworkUpdaterBase();

    /// WM_INITDIALOGƂĂԂׂ
    void UpdateGetInfo();
    /// GetInfo()Iđs{^ꂽ肵ĂԂׂ
    void Update();

    /// 𒆒f(Ԃ)
    void CancelUpdate();
    /// 𒆒f(I܂ő҂)
    void StopUpdate();

private:
    /// RtBOIuWFNg̎擾
    virtual CConfig& GetConfig() = 0;
    /// RtBO̊B̕{FXȐݒǂݏ
    virtual string GetConfigBaseName() = 0;
    /// XVt@Ĉtqk̎擾
    virtual string GetUpdateUrl() const = 0;
    /// ÂNotice̕\BGetInfo()̍ŏɌĂ΂
    virtual void OnOldNotice(const vector<string>& vctOldNotice) = 0;
    /// GetInfo()̐i󋵃R[obNBfꍇfalseԂB
    virtual void OnGetInfoProgress(unsigned nCurrent, unsigned nMax) = 0;
    /// Abvf[g݂ȂꍇGetInfo()IʒmB
    virtual void OnGetInfoNoUpdate() = 0;
    /// Abvf[g݂ꍇGetInfo()IʒmB
    virtual void OnGetInfo(const CNetworkUpdateInfo& oInfo) = 0;
    /// Update()̐i󋵃R[obNBfꍇfalseԂB
    virtual void OnUpdateProgress(const string& strFileName, unsigned nCurrent, unsigned nMax, unsigned nCurrentAll, unsigned nMaxAll) = 0;
    /// Iăt@C̍XVsO̍ŏImFBfꍇ false B
    virtual bool ConfirmUpdate() = 0;
    /// obNAbvIʒmBт̌ÂobNAbv`̂obNAbvׂɍs _no
    virtual void OnEndBackup() = 0;
    /// G[ôŃ_CAO
    virtual void OnError() = 0;
    /// EBhEďIs
    virtual void PostQuit() = 0;

private:
    void OnGetInfoThread();
    void OnUpdateThread();

    void HttpHead(const string& strUrl, SHttpReceiveData& rData);
    void HttpGet(const string& strUrl, SHttpReceiveData& rData);
    bool ExistsUpdateFile();

    void OnProgress(unsigned nCurrent, unsigned nMax);

private:
    int m_nMode;                // 0:GetInfo  1:Update
    unsigned m_nCurrentOld;     // OnCurrent̃TCY
    unsigned m_nCurrentAll;     // Update̎擾TCY
    unsigned m_nMaxAll;         // UpdateInfo瓾t@CTCY̍vB
    string m_strCurrentFile;    // ݃_E[h̃t@C
    auto_ptr<CTempDir> m_pTempDir;
 // string m_strLastModified;
    CNetworkUpdateInfo m_oInfo;

    volatile bool threadValid;
    std::tr1::shared_ptr<WorkerThreadController> thread;
};

}
