#include "stdafx.h"
#include "tpl/smart_obj.h"
#include "Timer.h"
#include "Profiler.h"
namespace Themis {

struct SProfileData {
    string name;
    int nCallCount;
    unsigned nTotalTime;
    SProfileData() : nTotalTime(0), nCallCount(0) {}
    string ToStr() const {
        return string::Format(L"%s:\t%6d times, %6d [ms]", name.ToCharPtr(), nCallCount, nTotalTime);
    }
    bool operator<(const SProfileData& r) const { return name < r.name; }
};

class CProfilerOwner {
    std::map<string, smart_obj<SProfileData> > m_map;
    CProfilerOwner() {
        CTimer::Begin();
    }
public:
    ~CProfilerOwner() {
        CTimer::End();
        // Kɕבւ
        std::set<SProfileData> s;
        for (std::map<string, smart_obj<SProfileData> >::iterator it = m_map.begin(); it != m_map.end(); ++it) {
            s.insert(*it->second);
        }
        // ʕ\
        Themis_DebugAlwaysLog(L"-------Profile Info-------");
        for (std::set<SProfileData>::iterator it = s.begin(); it != s.end(); ++it) {
            Themis_DebugAlwaysLog((*it).ToStr());
        }
        Themis_DebugAlwaysLog(L"--------------------------");
    }
    static CProfilerOwner& GetInst() {
        static CProfilerOwner m_oInst;
        return m_oInst;
    }
    SProfileData* Get(const string& name) {
        return m_map[name].GetPtr().get();
    }
};

CProfiler::CProfiler(const string& name) {
    m_pData = CProfilerOwner::GetInst().Get(name);
    m_pData->name = name;
    m_pData->nCallCount++;
    m_nStartTime = CTimer::Get();
}

CProfiler::~CProfiler() {
    m_pData->nTotalTime = CTimer::Get() - m_nStartTime;
}

}
