#include "stdafx.h"
#include "Spi.h"
#include "File.h"
#include "Windows/Dll.h"
#include "Windows/Registry.h"
#include "Windows/PushDir.h"
namespace Themis {

CSpi::CSpi() {
}

CSpi::CSpi(const CFileName& oSpiDir) {
    SetDir(oSpiDir);
}

CSpi::~CSpi() {
}

void CSpi::SetDir(const CFileName& oSpiDir) {
    Themis_DebugAssert(oSpiDir.IsDirPath());
    if (m_oDir != oSpiDir) {
        m_oDir = oSpiDir;
        m_oDllList.clear();

        vector<CFileName> vct;
        try {
            if (CFile(m_oDir).ExistsDir()) {
                vct = CFile::FindFile(m_oDir, 0);
            }
        } catch (std::exception&) {}  //sĂ
        if (!vct.empty()) {
            PushDir pushDir(m_oDir);
            for (size_t i = 0, n = vct.size(); i < n; i++) {
                try {
                    if (vct[i].GetSuffixLc() == L"spi") {  //gq̂͂܂DȂǁBB
                        m_oDllList.push_back(new CDll(vct[i].Get()));
                    }
                } catch(...) {
                }
            }
        }
    }
}

string CSpi::GetName(int i) const {
    return CFileName(m_oDllList[i].GetFileName()).GetPrefix(); //PureNameɂׂH
}

SPI::GetPluginInfo CSpi::GetPluginInfo(int i) const {
    return static_cast<SPI::GetPluginInfo>(m_oDllList[i].GetProc(L"GetPluginInfo"));
}
SPI::IsSupported CSpi::IsSupported(int i) const {
    return static_cast<SPI::IsSupported>(m_oDllList[i].GetProc(L"IsSupported"));
}
SPI::GetPictureInfo CSpi::GetPictureInfo(int i) const {
    return static_cast<SPI::GetPictureInfo>(m_oDllList[i].GetProc(L"GetPictureInfo"));
}
SPI::GetPicture CSpi::GetPicture(int i) const {
    return static_cast<SPI::GetPicture>(m_oDllList[i].GetProc(L"GetPicture"));
}
SPI::GetPreview CSpi::GetPreview(int i) const {
    return static_cast<SPI::GetPreview>(m_oDllList[i].GetProc(L"GetPreview"));
}
SPI::GetArchiveInfo CSpi::GetArchiveInfo(int i) const {
    return static_cast<SPI::GetArchiveInfo>(m_oDllList[i].GetProc(L"GetArchiveInfo"));
}
SPI::GetFileInfo CSpi::GetFileInfo(int i) const {
    return static_cast<SPI::GetFileInfo>(m_oDllList[i].GetProc(L"GetFileInfo"));
}
SPI::GetFile CSpi::GetFile(int i) const {
    return static_cast<SPI::GetFile>(m_oDllList[i].GetProc(L"GetFile"));
}
SPI::ConfigurationDlg CSpi::ConfigurationDlg(int i) const {
    return static_cast<SPI::ConfigurationDlg>(m_oDllList[i].GetProc(L"ConfigurationDlg"));
}

bool CSpi::IsImportFilter(int i) const {
    SPI::GetPluginInfo gpi = GetPluginInfo(i);
    Themis_DebugAssert(gpi != NULL);
    char sz[0x10]; // {Sł̂ꉞ]TĂB
    if (gpi(0, sz, 5) < 4) {
        return false;
    }
    return sz[2] == L'I';
}

bool CSpi::IsArchiveExtractor(int i) const {
    SPI::GetPluginInfo gpi = GetPluginInfo(i);
    Themis_DebugAssert(gpi != NULL);
    char sz[0x10]; // {Sł̂ꉞ]TĂB
    if (gpi(0, sz, 5) < 4) {
        return false;
    }
    return sz[2] == L'A';
}

string CSpi::GetInstallDir() {
    try {
        if (!CRegistry::Exists(HKEY_CURRENT_USER, L"Software\\Takechin\\Susie\\InstallRoot")) {
            return string();
        }
        CRegistry oReg;
        oReg.Open(HKEY_CURRENT_USER, L"Software\\Takechin\\Susie\\InstallRoot", false);
        return CFileName(oReg.Str(string())).AddDirSeparator();
    } catch (std::exception&) {
        return string();
    }
}

/// "*.AAA;*.BBB" ȕparseĊgq̃Xgɂwp֐B
void CSpi::SplitSuffixes(vector<string>& vct, const string& str) {
    List<string> patterns = str.Split(Array(L';'),
        StringSplitOptions::RemoveEmptyEntries);
    for (size_t i = 0, n = patterns.size(); i < n; i++) {
        int pos = patterns[i].IndexOf(L'.');
        if (0 <= pos) {
            vct.push_back(patterns[i].Substring(pos + 1).ToLower());
        } else {
            Themis_DebugWarning(L"ΉȌ`: " + patterns[i]);
        }
    }
}

}
