#pragma once
namespace Themis {

namespace SPI {
#ifdef __cplusplus
extern "C" {
#endif
    #include <pshpack1.h>

        typedef struct PictureInfo {
            long left,top;          // 摜WJʒu
            long width;             // 摜̕(pixel)
            long height;            // 摜̍(pixel)
            WORD x_density;         // f̐x
            WORD y_density;         // f̐x
            short colorDepth;       // fbit
            HLOCAL hInfo;           // 摜̃eLXg[Ăяo]
        } PictureInfo;

        typedef struct fileInfo {
            unsigned char method[8];    // k@̎
            unsigned long position;     // t@Cł̈ʒu
            unsigned long compsize;     // kꂽTCY
            unsigned long filesize;     // ̃t@CTCY
            uint32_t/*time_t*/ timestamp;           // t@C̍XV
            char path[200];             // ΃pX
            char filename[200];         // t@Cl[
            unsigned long crc;          // CRC
        } fileInfo;

    #include <poppack.h>


    // Common Function
    typedef int (PASCAL* GetPluginInfo)(int infono, LPSTR buf,int buflen);
    typedef int (PASCAL* IsSupported)(LPSTR filename,DWORD dw);

    // '00IN'̊֐
    typedef int (PASCAL* GetPictureInfo)(LPSTR buf,long len,unsigned int flag, PictureInfo *lpInfo);
    typedef int (PASCAL* GetPicture)(LPSTR buf,long len,unsigned int flag, HANDLE *pHBInfo,HANDLE *pHBm,
                                    FARPROC lpPrgressCallback,long lData);
    typedef int (PASCAL* GetPreview)(LPSTR buf,long len,unsigned int flag, HANDLE *pHBInfo,HANDLE *pHBm,
                                    FARPROC lpPrgressCallback,long lData);

    // '00AM'̊֐
    typedef int (PASCAL* GetArchiveInfo)(LPSTR buf, long len, unsigned int flag, HLOCAL *lphInf);
    typedef int (PASCAL* GetFileInfo)(LPSTR buf,long len, LPSTR filename, unsigned int flag, fileInfo *lpInfo);
    typedef int (PASCAL* GetFile)(LPSTR src,long len, LPSTR dest,unsigned int flag, FARPROC prgressCallback,long lData);

    // Plug-in̐ݒ_CAO(Susie32 v0.40ǉꂽSPI)
    enum {
        CONFIGDLG_ABOUT = 0,
        CONFIGDLG_SETTING,
        CONFIGDLG_RESERVED
    };
    typedef int (PASCAL* ConfigurationDlg)(HWND parent,int fnc);

#ifdef __cplusplus
}
#endif
}//namespace SPI

class CDll;

/**
    vOCXgB
*/
class CSpi : private boost::noncopyable {
public:
    CSpi();
    CSpi(const CFileName& oSpiDir);
    ~CSpi();

    /// SPIt@CfBNgݒ
    void SetDir(const CFileName& oSpiDir);
    /// fBNg̎擾
    const CFileName& GetDir() const { return m_oDir; }

    /// vOČ擾
    int GetCount() const { return static_cast<int>(m_oDllList.size()); }
    /// vOC̖O擾
    string GetName(int i) const;

    //@{ ֐̎擾
    SPI::GetPluginInfo GetPluginInfo(int i) const;
    SPI::IsSupported IsSupported(int i) const;
    SPI::GetPictureInfo GetPictureInfo(int i) const;
    SPI::GetPicture GetPicture(int i) const;
    SPI::GetPreview GetPreview(int i) const;
    SPI::GetArchiveInfo GetArchiveInfo(int i) const;
    SPI::GetFileInfo GetFileInfo(int i) const;
    SPI::GetFile GetFile(int i) const;
    SPI::ConfigurationDlg ConfigurationDlg(int i) const;
    //@}

    /// 摜ǂݍ݃vOCȂ̂
    bool IsImportFilter(int i) const;
    /// ɉ𓀃vOCȂ̂
    bool IsArchiveExtractor(int i) const;

    /// susiẽCXg[tH_̎擾Bs󕶎Ԃ
    static string GetInstallDir();

    /// "*.AAA;*.BBB" ȕparseĊgq̃Xgɂwp֐B
    static void SplitSuffixes(vector<string>& vct, const string& str);
    // ɏ̂͂藈Ȃ̂́A摜ƏɂŎĝłƂ肠BB

private:
    CFileName m_oDir;
    boost::ptr_deque<CDll> m_oDllList;
};


}
