#pragma once
#include "String.h"
namespace Themis {

void EncodingInitializeLocale();

/**
 * R[h̕ϊsNXB
 * byte[] ̑́Astd::stringAchar[]̑std::wstringŁB
 */
class Encoding : private boost::noncopyable {
protected:
    Encoding();
    //Encoding(int codePage);

public:
    //static Encoding& GetASCII();
    //static Encoding& GetBigEndianUnicode();
    static Encoding& GetDefault();
    //static Encoding& GetUnicode();
    //static Encoding& GetUTF32();
    //static Encoding& GetUTF7();
    //static Encoding& GetUTF8();
    //static Encoding& GetEncoding(int codepage);
    //static Encoding& GetEncoding(string name);
    //static Encoding& GetEncoding(int codepage, EncoderFallback encoderFallback, DecoderFallback decoderFallback);
    //static Encoding& GetEncoding(string name, EncoderFallback encoderFallback, DecoderFallback decoderFallback);
    //static EncodingInfo[] GetEncodings();

    //virtual string BodyName { get; }
    //virtual int CodePage { get; }
    //DecoderFallback DecoderFallback { get; set; }
    //EncoderFallback EncoderFallback { get; set; }
    //virtual string EncodingName { get; }
    //virtual string HeaderName { get; }
    //virtual bool IsBrowserDisplay { get; }
    //virtual bool IsBrowserSave { get; }
    //virtual bool IsMailNewsDisplay { get; }
    //virtual bool IsMailNewsSave { get; }
    //bool IsReadOnly { get; }
    //virtual bool IsSingleByte { get; }
    //virtual string WebName { get; }
    //virtual int WindowsCodePage { get; }

    //virtual object Clone() const;
    //override bool Equals(object value) const;
    //override int GetHashCode() const;

    //virtual int GetByteCount(const std::wstring& chars) const;
    //virtual int GetByteCount(const string& s) const;
    //virtual int GetByteCount(wchar_t* chars, int count) const;
    //virtual int GetByteCount(const std::wstring& chars, int index, int count) const = 0;
    //@{ stringstd::string
    std::string GetBytes(const std::wstring& chars) const {
        return GetBytes(chars, 0, static_cast<int>(chars.length()));
    }
    std::string GetBytes(const string& s) const {
        return GetBytes(s.ToCharArray(), 0, s.GetLength());
    }
    std::string GetBytes(const std::wstring& chars, int index, int count) const {
        std::string buffer(GetMaxByteCount(count) + 1, '\0');
        int n = GetBytes(chars, index, count, buffer, 0);
        return std::string(buffer.begin(), buffer.begin() + n);
        // ̂܂ܕԂƃ̖ʂɂȂ肻ȋCȂȂ̂ŖIɃRsĂ݂B
        // std::string̎ł͗]vȂb̋CȂȂcB
    }
    virtual int GetBytes(const wchar_t* chars, int charCount, char* bytes, int byteCount) const = 0;
    int GetBytes(const std::wstring& chars, int charIndex, int charCount, std::string& bytes, int byteIndex) const {
        BOOST_ASSERT(0 <= charIndex && 0 <= charCount && charIndex + charCount <= static_cast<int>(chars.length()));
        return GetBytes(chars.c_str() + charIndex, charCount,
            &bytes[0] + byteIndex, static_cast<int>(bytes.size()) - byteIndex - 1);
    }
    int GetBytes(const string& s, int charIndex, int charCount, std::string& bytes, int byteIndex) const {
        return GetBytes(s.ToCharArray(), charIndex, charCount, bytes, byteIndex);
    }
    //@}
    //virtual int GetCharCount(const std::string& bytes) const;
    //virtual int GetCharCount(const char* bytes, int count) const;
    //virtual int GetCharCount(const std::string& bytes, int index, int count) = 0 const;
    //virtual std::wstring GetChars(const std::string& bytes) const;
    //virtual std::wstring GetChars(const std::string& bytes, int index, int count) const;
    //virtual int GetChars(const char* bytes, int byteCount, wchar_t* chars, int charCount) const;
    //virtual int GetChars(const std::string& bytes, int byteIndex, int byteCount, std::wstring& chars, int charIndex) = 0 const;
    //virtual Decoder GetDecoder() const;
    //virtual Encoder GetEncoder() const;
    virtual int GetMaxByteCount(int charCount) const = 0;
    virtual int GetMaxCharCount(int byteCount) const = 0;
    //virtual byte[] GetPreamble();
    //@{ std::stringstring
    string GetString(const std::string& bytes) const {
        return GetString(bytes, 0, static_cast<int>(bytes.length()));
    }
    virtual string GetString(const std::string& bytes, int index, int count) const;
    //@}

    //@{ ɐKĂȂtrue
    bool IsAlwaysNormalized() { return IsAlwaysNormalized(NormalizationForm::FormC); }
    virtual bool IsAlwaysNormalized(NormalizationForm::T form) { return false; }
    //@}
};

}
