#include "stdafx.h"
#include "ThreadedWork.h"
namespace Themis {

ThreadedWork::ThreadedWork() : finished(true), waiting(false) {
    workingThreadId = 0;
}

ThreadedWork::ThreadedWork(const std::tr1::function<void()>& w) : work(w), finished(true), waiting(false) {
    workingThreadId = 0;
}

ThreadedWork::~ThreadedWork() {
    Themis_DebugAssert(finished);
}


/// VworkZbgāAfinished = falseɂBworkĂяoĂOKB
void ThreadedWork::Reset(const std::tr1::function<void()>& w) {
    boost::mutex::scoped_lock lock(mutex);
    Themis_DebugAssert(finished || workingThreadId == ::GetCurrentThreadId());
 // Themis_DebugAssert(!waiting);
    work = w;
    finished = false;
}


/// worksB
void ThreadedWork::DoWork() {
    Themis_DebugAssert(!finished);
    Themis_DebugAssert(!work.empty());
    // ds
    workingThreadId = ::GetCurrentThreadId();
    std::tr1::function<void()> tmpWork;
    {
        boost::mutex::scoped_lock lock(mutex);
        tmpWork = work;
        work.clear();
    }
    // ds
    try {
        tmpWork();
    } catch (...) {
        WorkFinished();
        throw;
    }
    WorkFinished();
}

/// nB
void ThreadedWork::WorkFinished() {
    boost::mutex::scoped_lock lock(mutex);
    if (work.empty()) {
        finished = true;
    } else {
        Themis_DebugAssert(!finished);
    }
    if (waiting) {
        condition.notify_all();
    }
}

/// workI܂ő҂B
void ThreadedWork::Join() {
    boost::mutex::scoped_lock lock(mutex);
    Themis_DebugAssert(!waiting);
    if (!finished) {
        if (workingThreadId != ::GetCurrentThreadId()) {
            waiting = true;
            condition.wait(lock);
            waiting = false;
        }
    }
 // workĂ邩Ȃ̂ł͖B
 // Themis_DebugAssert(finished);
}


}
