#pragma once
#include "../tpl/smart_ptr_vector.h"
#include <tlhelp32.h> //PROCESSENTRY32
#include <shlobj.h> //ITEMIDLIST;
namespace Themis {

/**
    WindowsɈˑx̍܂܂Ƃ֐Ƃ
*/
class CSystem : private boost::noncopyable {
public:
    //@{ J[\̈ʒuE\
    static CPoint GetCursorPos();
    static void SetCursorPos(const CPoint& pt);
    static bool ShowCursor();
    static bool HideCursor();
    //@}
    /// gqɊ֘Atꂽt@C擾
    static string FindExec(const string& strSuffix);
    //@{ t@CS~
    static void DeleteFile(const CFileName& oFileName, bool confirm = true, HWND hWndParent = NULL);
    static void DeleteFile(const vector<CFileName>& vctFiles, bool confirm = true, HWND hWndParent = NULL);
    //@}
    /// iv}CfBXvĆj[NGA(^XNo[ʏ)̃TCY擾
    static CRect GetWorkArea();
    /// SẴ[NGÃTCY擾B
    static vector<CRect> GetAllWorkAreas();
    /// SẴXN[̃TCY擾B
    static vector<CRect> GetAllScreensRect();
    /// SẴXN[𕢂Rect擾B
    static CRect GetScreensCoverRect();
    /// fXNgbvŜ̑傫擾
    static CSize GetDesktopSize() { return CSize(::GetSystemMetrics(SM_CXSCREEN), ::GetSystemMetrics(SM_CYSCREEN)); }
    /// Win2kȍ~Ȃtrue
    static bool Is2kLater();
    struct SProcessMemory {
        unsigned nPageFaultCount;
        size_t nPeakWorkingSetSize;
        size_t nWorkingSetSize;
        size_t nQuotaPeakPagedPoolUsage;
        size_t nQuotaPagedPoolUsage;
        size_t nQuotaPeakNonPagedPoolUsage;
        size_t nQuotaNonPagedPoolUsage;
        size_t nPagefileUsage;
        size_t nPeakPagefileUsage;
    };
    /// vZXgĂ郁̗ʂ擾
    static SProcessMemory GetProcessMemoryInfo();
    /// ̎gp\ʂƍőʂ擾
    static pair<uint64_t, uint64_t> GetPhysicalMemorySize();
    //@{ OSI / ċN
    static bool Shutdown();
    static bool Reboot();
    //@}
    //@{ ǎ̕ύX
    static void SetWallpaper(const string& strFileName);
    static void SetWallpaperDefault();
    static void UnsetWallpaper();
    //@}
    //@{ Nbv{[h֌W
    static bool GetClipboard(string& str);
    static bool GetClipboard(HDC hdc, const CPoint& pt, CSize& sz);
    static void SetClipboard(const string& str);
    static void SetClipboard(HDC hdc, const CRect& rc);
 // static void SetClipboard(const BITMAPV5HEADER& bif, const uint32_t* pBits, int nPitch);
    //@}
    /// tHg̃Xg쐬
    static vector<string> GetFontList();
    /// tHg̃Xg쐬
    static vector<string> GetAnsiFontList();
    /// ̎_ő݂鑋
    static vector<HWND> GetWindowList();
    /// ̎_ŋNĂvZX̃XibvVbg擾
    static vector<PROCESSENTRY32> GetProcessSnapshot();
    /// nhȂĂ郂W[擾
    static string GetModuleName(HWND hWnd);
    /// vZX̃XibvVbgAnhɁȂĂ郂W[擾
    static string GetModuleName(HWND hWnd, const vector<PROCESSENTRY32>& oPe);
    /// W[瑋nhB
    static HWND GetWindow(const string& strModuleName);
    /// ̎st@C擾
    static string GetModuleFileName();
    //@{ FXȃfBNg̎擾
    static string GetTempDir();
    static string GetAppDataDir();
    static string GetCommonDesktopDir();
    static string GetCommonFavoritesDir();
    static string GetCommonProgramsDir();
    static string GetCommonStartMenuDir();
    static string GetCommonStartupDir();
    static string GetCookiesDir();
    static string GetDesktopDir();
    static string GetFavoritesDir();
    static string GetFontsDir();
    static string GetHistoryDir();
    static string GetInternetCacheDir();
    static string GetNetHoodDir();
    static string GetMyDocumentsDir();
    static string GetPrintHoodDir();
    static string GetProgramsDir();
    static string GetRecentDir();
    static string GetSendToDir();
    static string GetStartMenuDir();
    static string GetStartupDir();
    static string GetTemplatesDir();
    static string GetMyPicturesDir();
    //@}

    //@{ ϐ
    static string GetEnv(const string& strName);
    static void SetEnv(const string& strName, const string& strValue);
    //@}

    /// ǗҌŎsĂȂtrue
    static bool IsUserAnAdmin(bool defaultValue = false);

    struct SDriveInfo {
        const string strPath;           // "C:\\" ƂB
        const string strName;           // {[xȂ
        const string strTypeName;       // L"[J fBXN", L"CD hCu" ȂǁB
        const HICON hIcon;              // ACR
        SDriveInfo(const string& p, const string& n, const string& t, HICON h);
        ~SDriveInfo();
    };
    /// hCũXg쐬
    static smart_ptr_vector<CSystem::SDriveInfo> EnumDrives();

    /// \[X̕e[uǂݏo
    static string LoadResource(UINT nId);

    struct SShortcutInfo {
        SShortcutInfo(); ///< ftHgl̐ݒ
        string strTarget;
        string strArguments;
        string strWorkDir;
        string strDescription;
        string strIconFile;
        int nIcon;
        int nShowCmd;   //< SW_SHOWNORMAL, SW_SHOWMAXIMIZED, SW_SHOWMINNOACTIVE
    };
    /// V[gJbgt@C(*.lnk)̍쐬
    static void CreateShortcut(const CFileName& oFileName, const SShortcutInfo& o);
    static SShortcutInfo GetShortcutInfo(const CFileName& oFileName);

    struct SRelationFileTypeInfo {
        // ̐ݒ͑SȂݒ肵ȂƂƂŁB
        string strCommand;     //< WXg (strFileType)\\shell\\(strCommand)\\command ɓo^BȂopenB
        string strMenuName;    //< ENbNj[ɕ\镶Bopen̎͋łH
        string strCommandLine;
        string strDescription; //< GNXv[́uށvɕ\
        string strIconFile;
        int nIcon;
    };
    /// ֘At̓o^
    static void RegisterRelation(const string& strSuffix, const string& strFileType, const string& strContentType = string());
    /** ֘AtAv̓o^B
        strFileType == L"Folder" ɂƃtH_̉ENbNj[ɏoH
        HKEY_CLASSES_ROOT\\CLSID\\{C96401CC-0E17-11D3-885B-00C04F72C717} Ƃ
        HKEY_CLASSES_ROOT\\Interface\\{BBCBDE60-C3FF-11CE-8350-444553540000} ƂɂL"Folder"Ă̂̂CɂȂ邯ǁBB
    */
    static void RegisterRelationFileType(const string& strFileType, const SRelationFileTypeInfo& o);
    /// ֘At̍폜
    static void DeleteRelation(const string& strSuffix, const string& strFileType);
    /// ֘AtAv̍폜(S)
    static void DeleteRelationFileType(const string& strFileType);
    /// ֘AtAv̍폜(̃R}h)
    static void DeleteRelationCommand(const string& strFileType, const string& strCommand);
    /// gqɊ֘AtꂽAv̎擾
    static string GetRelationFileType(const string& strSuffix);
    /// ֘AtĂ邩ǂ
    static bool IsRelationFileType(const string& strSuffix, const string& strFileType);
    /// R}ho^Ă邩ǂ
    static bool IsRelationCommand(const string& strFileType, const string& strCommand);
    /// ֘AtݒVXeɔf
    static void NotifyRelation();

    /// t@CITEMIDLIST쐬
    static ITEMIDLIST* GetItemIDList(const CFileName& oFileName);
    /// ITEMIDLISTt@C擾
    static string GetPath(ITEMIDLIST* pIL);
};

}
